SportStore/Components/CartSummaryViewComponent.cs
using Microsoft.AspNetCore.Mvc;
using SportsStore.Models;

namespace SportsStore.Components
{
    public class CartSummaryViewComponent : ViewComponent
    {
        private Cart cart;

        public CartSummaryViewComponent(Cart cartService)
        {
            cart = cartService;
        }

        public IViewComponentResult Invoke()
        {
            return View(cart);
        }
    }
}

SportStore/Components/NavigationMenuViewComponent.cs
using System;
using Microsoft.AspNetCore.Mvc;
using System.Linq;
using SportsStore.Models;

namespace SportsStore.Components
{
    public class NavigationMenuViewComponent : ViewComponent
    {
        private IStoreRepository repository;

        public NavigationMenuViewComponent(IStoreRepository repository)
        {
            this.repository = repository ?? throw new ArgumentNullException(nameof(repository));
        }

        public IViewComponentResult Invoke()
        {
            ViewBag.SelectedCategory = RouteData?.Values["category"];
            
            return View(repository.Products
                .Select(x => x.Category)
                .Distinct()
                .OrderBy(x => x));
        }
    }
}

SportStore/Controllers/CartController.cs
using System;
using System.Linq;
using Microsoft.AspNetCore.Mvc;
using SportsStore.Models;
using SportsStore.ViewModels;

namespace SportsStore.Controllers
{
    public class CartController : Controller
    {
        private readonly IStoreRepository repository;
        private readonly Cart cart;

        public CartController(IStoreRepository repository, Cart cartService)
        {
            this.repository = repository ?? throw new ArgumentNullException(nameof(repository));
            this.cart = cartService ?? throw new ArgumentNullException(nameof(cartService));
        }

        [HttpGet]
        public IActionResult Index(string returnUrl)
        {
            return View(new CartViewModel
            {
                ReturnUrl = returnUrl ?? "/"
            });
        }

        [HttpPost]
        public IActionResult Index(long productId, string returnUrl)
        {
            Product product = repository
                .Products
                .FirstOrDefault(p => p.ProductId == productId);

            cart.AddItem(product, 1);

            return View(new CartViewModel
            {
                Cart = cart,
                ReturnUrl = returnUrl
            });
        }

        [HttpPost]
        public IActionResult Remove(long productId, string returnUrl)
        {
            cart.RemoveLine(cart.Lines.First(cl => cl.Product.ProductId == productId).Product);
            
            return View("Index", new CartViewModel
            {
                Cart = cart,
                ReturnUrl = returnUrl ?? "/"
            });
        }
    }
}

SportStore/Views/Shared/ProductSummary.cshtml
@model Product

<div class="card card-outline-primary m-1 p-1">

    <div class="bg-faded p-1">
        <h4>
            @Model.Name
            <span class="badge badge-pill badge-primary" style="float:right">
                <small>@Model.Price.ToString("c")</small>
            </span>
        </h4>
    </div>

    <form id="@Model.ProductId" method="post" asp-action="Index" asp-controller="Cart"  asp-antiforgery="true">
        <input type="hidden" asp-for="ProductId"/>
        <input type="hidden" name="returnUrl"
               value="@ViewContext.HttpContext.Request.PathAndQuery()"/>
        <span class="card-text p-1">
            @Model.Description
            <button type="submit" class="btn btn-success btn-sm pull-right" style="float:right">
                Add To Cart
            </button>
        </span>
    </form>

</div>

SportStore/Views/Shared/_CartLayout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta name="viewport" content="width=device-width"/>
    <title>SportsStore</title>
    <link href="/lib/twitter-bootstrap/css/bootstrap.min.css" rel="stylesheet"/>
</head>
<body>
<div class="bg-dark text-white p-2">
    <span class="navbar-brand ml-2">SPORTS STORE</span>
</div>
<div class="m-1 p-1">
    @RenderBody()
</div>
</body>
</html>

SportStore/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta name="viewport" content="width=device-width"/>
    <title>SportsStore</title>
    <link href="/lib/twitter-bootstrap/css/bootstrap.min.css" rel="stylesheet"/>
    <link href="/lib/font-awesome/css/all.min.css" rel="stylesheet"/>
</head>
<body>
<div class="bg-dark text-white p-2">
    <div class="container-fluid">
        <div class="row">
            <div class="col navbar-brand">SPORTS STORE</div>
            <div class="col-6 text-right">
                <vc:cart-summary/>
            </div>
        </div>
    </div>
</div>
<div class="row m-1 p-1">
    <div id="categories" class="col-3">
        <vc:navigation-menu/>
    </div>
    <div class="col-9">
        @RenderBody()
    </div>
</div>
</body>
</html>